var pusheo;
var sender;
var receiver;
$(document).ready(function() {
	
	$('#chatBox').hide();
	$('.textArea').keydown(function(e) {
	  if(e.which == 13) {
		e.preventDefault();
		var msg=$('.textArea').val();
		if(msg.length!==0)
		{
			$('.chatContent').append('<div class="message"><b>'+sender+' : </b>'+msg+'</div>');
			$('.chatContent').scrollTop($('.chatContent')[0].scrollHeight);
			pusheo.publish({
					channel: receiver,
					message: msg
				});
		}
		$('.textArea').val('');
	  }
	});
	
	$('.textArea').focusin( function(e){
		$('.textArea').css('border-color','#0A737C');
	});
	
	$('.textArea').focusout( function(e){
		$('.textArea').css('border-color','#E6DEDE');
	});
});

function activateUser(flag){
	$('#chatBox').show();
	$('.user').hide();
	if(flag==1) {
		sender="user1";
		receiver="user2";
		$('.chatHead').append('User 2');
		$('.chatHead').append('<div class="chatOptions"><a href="javascript:minimize()">-</a><a href="javascript:unsubscribeUser()">X</a></div>');
		$('.loginMessage').append('You have logged in as User 1');
	} else if(flag==2){
		sender="user2";
		receiver="user1";
		$('.chatHead').append('User 1');
		$('.chatHead').append('<div class="chatOptions"><a href="javascript:minimize()">-</a><a href="javascript:unsubscribeUser()">X</a></div>');
		$('.loginMessage').append('You have logged in as User 2');
	}
	subscribeUser();
}

function subscribeUser(){

/* Initialize Pusheo object */
	pusheo = new Pusheo({
            publish_key: "demo",
            subscribe_key: "demo",
            url: "http://localhost:8080/pusheo/"
		});
		
/* Subscibe to channel identified by sender using this object*/
	pusheo.subscribe({
            channel: sender,
            lost_messages_call: false,
            open: onOpen,
            message: onMessage,
			message_sent: onMessageSent,
            close: onClose,
            error: onError,
		});
}

function unsubscribeUser(){
	pusheo.unsubscribe({
            channel: sender
        });
	$('#chatBox').hide();
	$('.user').show();
	$('.loginMessage').html('');
	$('.chatHead').html('');
	$('.chatContent').html('');
	
}

function minimize(){
	$('.chatContent').toggle();
	$('.chatInputBox').toggle();
}


/*
 *Callback functions
 */

function onOpen(response) {
	//alert("opened")
	console.log("opened");
}

function onMessage(response) {
	$('.chatContent').append('<div class="message"><b>'+receiver+' : </b>'+response+'</div>');
	$('.chatContent').scrollTop($('.chatContent')[0].scrollHeight);
}

function onMessageSent(response) {
	console.log("message sent ");
}

function onClose(response) {
	console.log("closed");
}

function onError(response) {
	console.log("Error");
}

/*Callback functions end*/